
local LBF = LibStub("LibButtonFacade", true)
local L = LibStub("AceLocale-3.0"):GetLocale("Watcher")
local AceAddon = LibStub("AceAddon-3.0")
local media = LibStub:GetLibrary("LibSharedMedia-3.0");
Watcher = AceAddon:NewAddon("Watcher", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0")
local SCT = SCT
local REVISION = tonumber(("$Revision: 19 $"):match("%d+"))
local _, _, _, clientVersion = GetBuildInfo()
Watcher.constants = {}
local C = Watcher.constants -- Defined in Watcher LUA no locale needed.

local combat
local pvpinstance = false
Watcher.isBoss = true
Watcher.textures = {}
Watcher.borders = {}
Watcher.fonts = {}
Watcher.sounds = {}
Watcher.dir = {"right", "down", "left", "up"}

Watcher.PriorityFrame = CreateFrame("Frame", "SAA_PriorityFrame", UIParent)
Watcher.PriorityFrame.axisbase = CreateFrame("Frame", "SAA_PriorityFrameAB", Watcher.PriorityFrame)
Watcher.Priority1 = CreateFrame("Frame", "SAA_PriorityFrame1", Watcher.PriorityFrame)
Watcher.Priority2 = CreateFrame("Frame", "SAA_PriorityFrame2", Watcher.PriorityFrame)
Watcher.Priority3 = CreateFrame("Frame", "SAA_PriorityFrame3", Watcher.PriorityFrame)
Watcher.Priority4 = CreateFrame("Frame", "SAA_PriorityFrame4", Watcher.PriorityFrame)
Watcher.Priority5 = CreateFrame("Frame", "SAA_PriorityFrame5", Watcher.PriorityFrame)
Watcher.Priority6 = CreateFrame("Frame", "SAA_PriorityFrame6", Watcher.PriorityFrame)
Watcher.Priority7 = CreateFrame("Frame", "SAA_PriorityFrame7", Watcher.PriorityFrame)
Watcher.Priority8 = CreateFrame("Frame", "SAA_PriorityFrame8", Watcher.PriorityFrame)
Watcher.PriorityGCD = CreateFrame("Frame", "SAA_PriorityFrameGCD", Watcher.PriorityFrame)
ready = {}
Watcher.offset = 0
Watcher.timeLeft = {0, 0, 0, 0, 0, 0, 0, 0, 0}
Watcher.PriorityFrame.axisbase.textmin = Watcher.PriorityFrame.axisbase:CreateFontString(nil, "OVERLAY")
Watcher.PriorityFrame.axisbase.text = Watcher.PriorityFrame.axisbase:CreateFontString(nil, "OVERLAY")
Watcher.textpoint = {}
Watcher.textpoint["top"] = "top"
Watcher.textpoint["bottom"] = "bottom"
Watcher.textpoint["center"] = "center"
Watcher.priorityTable = {}
Watcher.priorityTable.name = {}
Watcher.priorityTable.icon = {}
Watcher.priorityTable.check = {}
Watcher.fonts = {}

Watcher.defaults = {
	char = {
		enable = true,
		message = "Welcome Home!",
		barshow = true,
		showraid = false,
		showparty = false,
		alpha = 1,
		balpha = 0.6,
		showcombat = false,
		showicons = true,
		relativeTo = "UIParent",
		relativePoint = "CENTER",
		point = "CENTER",
		texture = "Blizzard",
		iconfont = "Friz Quadrata TT",
		iconfontsize = 12,
		iconfonteffect = "none",
		xOffset = 0,
		yOffset = -100,
		resetOn = true,
		scale = 1,
		showgcd = false,
		textpoint =  "top",
		showaxis = true,
		growdir = "right",
		disablebars = false,
		debug = false,
		stackmoving = false,
		priority = {
			show = true,
			textshow = true,
			relativeTo = "UIParent",
			relativePoint = "CENTER",
			point = "CENTER",
			fWidth = 50,
			fHeight = 50,
			IconSize = 50,
			xOffset = -185,
			yOffset = -40,
			alpha = 0.4,
			scale = 1,	
			onlyboss = { false, false, false, false, false, false, false, false, false},
			onlyboss1 = { false, false, false, false, false, false, false, false, false},
			onlyboss2 = { false, false, false, false, false, false, false, false, false},
			option2 = { "gcd", "none", "none", "none", "none", "none", "none", "none", "none"},
			option1 = { "gcd", "none", "none", "none", "none", "none", "none", "none", "none"},
			option = { "gcd", "none", "none", "none", "none", "none", "none", "none", "none"},
			maxtime = 10,
			interval = 2,
		},
	},
}

Watcher.priorityTable.name["none"] = L["None"]
_, _, Watcher.priorityTable.icon["none"] = "Interface/Tooltips/UI-Tooltip-Background"
Watcher.priorityTable.check["none"] = function () return end 


-------------
--Set Up / Event Functions
-------------
function Watcher:OnInitialize()
	local AceConfigReg = LibStub("AceConfigRegistry-3.0")
	local AceConfigDialog = LibStub("AceConfigDialog-3.0")
	self.db = LibStub("AceDB-3.0"):New("WatcherDBPC", Watcher.defaults, "char")
	LibStub("AceConfig-3.0"):RegisterOptionsTable("Watcher", self:GetOptions(), {"Watcher", "saa"} )
	media.RegisterCallback(self, "LibSharedMedia_Registered")
	self.optionsFrame = AceConfigDialog:AddToBlizOptions("Watcher","Watcher")
	self.optionsFrame[L["About"]] = LibStub("LibAboutPanel").new("Watcher", "Watcher")
	self.db:RegisterDefaults(self.defaults)
	self:SwitchTalents()
	if self.db.char.enable then
	self:CreatePriorityFrame()
	end
	local version = GetAddOnMetadata("Watcher","Version")
	self.version = ("Watcher v%s (r%s)"):format(version, REVISION)
	self:Print(self.version.." Loaded.")
end

function Watcher:OnEnable()
	self:LibSharedMedia_Registered()
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
	self:RegisterEvent("PLAYER_REGEN_DISABLED")
	self:RegisterEvent("PLAYER_REGEN_ENABLED")
	self:RegisterEvent("PLAYER_TALENT_UPDATE")
	self:RegisterEvent("RAID_ROSTER_UPDATE")
	self:RegisterEvent("PARTY_MEMBERS_CHANGED")
	self:RegisterEvent("UNIT_ENTERED_VEHICLE")
	self:RegisterEvent("UNIT_EXITED_VEHICLE")
	self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
	self:RegisterEvent("PLAYER_TARGET_CHANGED")
end

function Watcher:PLAYER_ENTERING_WORLD()
	local _, instance = IsInInstance()
	if instance == "pvp" or instance == "arena" then
	self.PriorityFrame:Hide()
	pvpinstance = true
	else
	self:CreatePriorityFrame()
	pvpinstance = false
	end
end
function Watcher:PLAYER_REGEN_DISABLED()
	if Watcher:scan() then
		Watcher.isBoss = true
	else
		Watcher.isBoss = false
	end
	combat = true
	self:CreatePriorityFrame()
end

function Watcher:PLAYER_REGEN_ENABLED()
	combat = false
	self:CreatePriorityFrame()
end

function Watcher:DisplayVersion()
	self:Print(self.version)
end

function Watcher:PLAYER_TALENT_UPDATE()
	self:SwitchTalents()	
	self:CreatePriorityFrame()
end

function Watcher:PLAYER_TARGET_CHANGED()
	if Watcher:scan() then
		Watcher.isBoss = true
		--self:Print(Watcher.isBoss)
	else
		Watcher.isBoss = false
		--self:Print(Watcher.isBoss)
	end
end


function Watcher:UNIT_SPELLCAST_SUCCEEDED()
end

function Watcher:LibSharedMedia_Registered()
	for k, v in pairs(media:List("font")) do
		self.fonts[v] = v
	end
end

function Watcher:scan()
	if Watcher:checkTarget("target") then return true end
	if Watcher:checkTarget("focus") then return true end
	if UnitInRaid("player") then
		for i = 1, GetNumRaidMembers() do
			if Watcher:checkTarget("raid"..i.."target") then return true end
		end
	else
		for i = 1, 5 do
			if Watcher:checkTarget("party"..i.."target") then return true end
		end
	end
	return false
end

function Watcher:checkTarget(id)
	return UnitExists(id) and UnitClassification(id) == "worldboss"
end

function Watcher:SwitchTalents()	
	local points = GetUnspentTalentPoints(false, false, GetActiveTalentGroup())
	local groupIndex = GetActiveTalentGroup()
	if points > 0 and groupIndex == 1 then
		self.db.char.priority.option1 = { "gcd", "none", "none", "none", "none", "none", "none", "none", "none"}
		self.db.char.priority.option = { "gcd", "none", "none", "none", "none", "none", "none", "none", "none"}
	elseif points > 0 and groupIndex == 2 then
		self.db.char.priority.option2 = { "gcd", "none", "none", "none", "none", "none", "none", "none", "none"}
		self.db.char.priority.option = { "gcd", "none", "none", "none", "none", "none", "none", "none", "none"}
	else
		if groupIndex == 1 then 
			self.db.char.priority.option = self.db.char.priority.option1
			self.db.char.priority.onlyboss = self.db.char.priority.onlyboss1
			
		elseif groupIndex == 2 then 
			self.db.char.priority.option = self.db.char.priority.option2
			self.db.char.priority.onlyboss = self.db.char.priority.onlyboss2
		end
	end
	
end

function Watcher:UNIT_ENTERED_VEHICLE()
	self:CreatePriorityFrame()
end

function Watcher:UNIT_EXITED_VEHICLE()
	self:CreatePriorityFrame()
end

function Watcher:CheckRaidParty()
	local raidnum = GetNumRaidMembers()
	local partynum = GetNumPartyMembers()
	if partynum > 0 and self.db.char.showparty == true then
		self.PriorityFrame:Show()
	elseif raidnum >= 1 and self.db.char.showraid == true then
		self.PriorityFrame:Show()
	else
		self.PriorityFrame:Hide()
	end
end

function Watcher:RAID_ROSTER_UPDATE()
	self:CreatePriorityFrame()
end

function Watcher:PARTY_MEMBERS_CHANGED()
	self:CreatePriorityFrame()
end

function Watcher:bossmob(optionnum)
	if self.db.char.priority.onlyboss[optionnum] and Watcher.isBoss then
		--self:Print(1)
		return true
	elseif not self.db.char.priority.onlyboss[optionnum] then
		--self:Print(2)
		return true
	else
		--self:Print(3)
		return false
	end
end


-------------------------------
-- Priority functions
-------------------------------


function Watcher:GetReady(optionnum)
	Watcher.offset = 0
	for index = 1, optionnum do
		if ready[index] == true then
			Watcher.offset = Watcher.offset + 1
		end
	end
end

function Watcher:SetReadyPoint(FrameName, offset)
	if self.db.char.growdir == "right" then
			FrameName:SetPoint("BOTTOMLEFT", Watcher.PriorityFrame, "BOTTOMLEFT", 0, (Watcher.db.char.priority.IconSize * 0.2) * (offset - 1))
	elseif self.db.char.growdir == "left" then
			FrameName:SetPoint("BOTTOMRIGHT", Watcher.PriorityFrame, "BOTTOMRIGHT", 0, (Watcher.db.char.priority.IconSize * 0.2) * (offset - 1))
	elseif self.db.char.growdir == "up" then
			FrameName:SetPoint("BOTTOMRIGHT", Watcher.PriorityFrame, "BOTTOMRIGHT", -(Watcher.db.char.priority.IconSize * 0.2) * (offset - 1), 0)
	elseif self.db.char.growdir == "down" then
			FrameName:SetPoint("TOPLEFT", Watcher.PriorityFrame, "TOPLEFT", -(Watcher.db.char.priority.IconSize * 0.2) * (offset - 1), 0)
	end
end

function Watcher:MoveIcon(FrameName, timeleft, optionnum)
	local Offset = 0
	if self.db.char.stackmoving then
		for i = 2, optionnum - 1 do
			if optionnum > 2 then
				if Watcher.timeLeft[i] > 0 then
					if ((timeleft) - Watcher.timeLeft[i]) >= -1.5 and ((timeleft) - Watcher.timeLeft[i]) <=1.50 then
						Offset = Offset + 1
					end
				end
			end
		end
	end
	if self.db.char.growdir == "up" then 
		FrameName:SetPoint("BOTTOMRIGHT", Watcher.PriorityFrame, "BOTTOMRIGHT",  -(Watcher.db.char.priority.IconSize * 0.2) * (Offset) , (timeleft * Watcher.db.char.priority.fWidth / 1.5))
	elseif self.db.char.growdir == "down" then 
		FrameName:SetPoint("TOPLEFT", Watcher.PriorityFrame, "TOPLEFT",  -(Watcher.db.char.priority.IconSize * 0.2) * (Offset) , -(timeleft * Watcher.db.char.priority.fWidth / 1.5))
	elseif self.db.char.growdir == "right" then 
		FrameName:SetPoint("BOTTOMLEFT", Watcher.PriorityFrame, "BOTTOMLEFT",  (timeleft * Watcher.db.char.priority.fWidth / 1.5) , (Watcher.db.char.priority.IconSize * 0.2) * (Offset))
	elseif self.db.char.growdir == "left" then 
		FrameName:SetPoint("BOTTOMRIGHT", Watcher.PriorityFrame, "BOTTOMRIGHT",  -(timeleft * Watcher.db.char.priority.fWidth / 1.5), (Watcher.db.char.priority.IconSize * 0.2) * (Offset))
	end
end

function Watcher:DurationString(duration)
    local string = (("%1.1f"):format(duration % 120));
    
    if (duration >= 120) then
        duration = floor(duration - (duration % 60)) / 60; -- minutes
        
        string = ((duration % 60) + 1) .."m " --.. string;
        
        if (duration >= 120) then
            duration = (duration - (duration % 60)) / 60; -- hours
            string = (duration + 1).. "h " --.. string;
        end
    end
    return string
end
--------------------------
--- Layout Functions
--------------------------
function Watcher:CreatePriorityFrame()
	if not self.db.char.enable then
		return
	end
	self.PriorityFrame:ClearAllPoints()
	self.PriorityFrame:SetScale(self.db.char.scale)
	self.PriorityFrame:SetFrameStrata("BACKGROUND")
	self.PriorityFrame:SetAlpha(self.db.char.alpha)
	if self.db.char.growdir == "right" then
	self.PriorityFrame:SetWidth(self.db.char.priority.IconSize + ((Watcher.db.char.priority.fWidth * self.db.char.priority.maxtime)/ 1.5))
	self.PriorityFrame:SetHeight(self.db.char.priority.IconSize)
	elseif self.db.char.growdir == "down" then
	self.PriorityFrame:SetHeight(self.db.char.priority.IconSize + ((Watcher.db.char.priority.fWidth * self.db.char.priority.maxtime)/ 1.5))
	self.PriorityFrame:SetWidth(self.db.char.priority.IconSize)
	elseif self.db.char.growdir == "left" then
	self.PriorityFrame:SetWidth(self.db.char.priority.IconSize + ((Watcher.db.char.priority.fWidth * self.db.char.priority.maxtime)/ 1.5))
	self.PriorityFrame:SetHeight(self.db.char.priority.IconSize)
	elseif self.db.char.growdir == "up" then
	self.PriorityFrame:SetHeight(self.db.char.priority.IconSize + ((Watcher.db.char.priority.fWidth * self.db.char.priority.maxtime)/ 1.5))
	self.PriorityFrame:SetWidth(self.db.char.priority.IconSize)
	end
	self.PriorityFrame:SetBackdrop({
		bgFile = "Interface/Tooltips/UI-Tooltip-Background",
		--edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
		tile = false, tileSize = 0, edgeSize = 12,
		insets = { left = 0, right = 0, top = 0, bottom = 0 }
	})
	self.PriorityFrame:SetBackdropColor(0, 0, 0, self.db.char.balpha);
	self.PriorityFrame:SetMovable(true);
	self.PriorityFrame:RegisterForDrag("LeftButton");
	self.PriorityFrame:SetPoint(self.db.char.priority.point, self.db.char.priority.relativeTo, self.db.char.priority.relativePoint, self.db.char.priority.xOffset, self.db.char.priority.yOffset)
	self.PriorityFrame:SetScript("OnDragStart", 
		function()
			self.PriorityFrame:StartMoving();
		end );
	self.PriorityFrame:SetScript("OnDragStop",
		function()
			self.PriorityFrame:StopMovingOrSizing();
			self.PriorityFrame:SetScript("OnUpdate", nil);
			self:FinishedMoving(self.db.char.priority, self.PriorityFrame);
		end );
	if self.db.char.showgcd then
	Watcher:SetPriorityFrame(self.PriorityGCD,1)
	else
	self.PriorityGCD:Hide()
	end
	Watcher:SetPriorityFrame(self.Priority1,2)
	Watcher:SetPriorityFrame(self.Priority2,3)
	Watcher:SetPriorityFrame(self.Priority3,4)
	Watcher:SetPriorityFrame(self.Priority4,5)
	Watcher:SetPriorityFrame(self.Priority5,6)
	Watcher:SetPriorityFrame(self.Priority6,7)
	Watcher:SetPriorityFrame(self.Priority7,8)
	Watcher:SetPriorityFrame(self.Priority8,9)
	self:Axis()
	if self.db.char.showcombat == true then
		if combat == true then
			self.PriorityFrame:Show()
		else
			self.PriorityFrame:Hide()
		end
	else 
		self.PriorityFrame:Show()
	end
	if pvpinstance == true then
		self.PriorityFrame:Hide()
	end
	if UnitInVehicle("player") then
		self.PriorityFrame:Hide()
	end
	if self.db.char.showraid == true or self.db.char.showparty == true then
		self:CheckRaidParty()
	end
end
	
function Watcher:AxisText()
	--Watcher.PriorityFrame.axisbase:Hide()
		--self.PriorityFrame.axisbase.text = Watcher.PriorityFrame.axisbase:CreateFontString(nil, "OVERLAY")
		self.PriorityFrame.axisbase.textmin:SetFont(media:Fetch("font", self.db.char.iconfont),12, self.db.char.iconfonteffect)
		self.PriorityFrame.axisbase.textmin:ClearAllPoints()
		if self.db.char.growdir == "right" then
		self.PriorityFrame.axisbase.textmin:SetPoint("TOP", self.PriorityFrame, "BOTTOMLEFT" , Watcher.db.char.priority.IconSize, -(12))
		elseif self.db.char.growdir == "left" then
		self.PriorityFrame.axisbase.textmin:SetPoint("TOP", self.PriorityFrame, "BOTTOMRIGHT" , -Watcher.db.char.priority.IconSize, -(12))
		elseif self.db.char.growdir == "up" then
		self.PriorityFrame.axisbase.textmin:SetPoint("LEFT", self.PriorityFrame, "BOTTOMRIGHT" ,( 12), Watcher.db.char.priority.IconSize)
		elseif self.db.char.growdir == "down" then
		self.PriorityFrame.axisbase.textmin:SetPoint("LEFT", self.PriorityFrame, "TOPRIGHT" ,( 12), -Watcher.db.char.priority.IconSize)
		end
		self.PriorityFrame.axisbase.textmin:SetText(0)
		self.PriorityFrame.axisbase.text:SetFont(media:Fetch("font", self.db.char.iconfont), 12, self.db.char.iconfonteffect)
		self.PriorityFrame.axisbase.text:ClearAllPoints()
		if self.db.char.growdir == "right" then
		self.PriorityFrame.axisbase.text:SetPoint("TOP", self.PriorityFrame, "BOTTOMLEFT" , Watcher.db.char.priority.IconSize +(Watcher.db.char.priority.fWidth * self.db.char.priority.maxtime / 1.5), -( 12))
		elseif self.db.char.growdir == "left" then
		self.PriorityFrame.axisbase.text:SetPoint("TOP", self.PriorityFrame, "BOTTOMRIGHT" , -Watcher.db.char.priority.IconSize -(Watcher.db.char.priority.fWidth * self.db.char.priority.maxtime / 1.5), -(12))
		elseif self.db.char.growdir == "up" then
		self.PriorityFrame.axisbase.text:SetPoint("LEFT", self.PriorityFrame, "BOTTOMRIGHT" ,(12), Watcher.db.char.priority.IconSize +(Watcher.db.char.priority.fWidth * self.db.char.priority.maxtime / 1.5))
		elseif self.db.char.growdir == "down" then
		self.PriorityFrame.axisbase.text:SetPoint("LEFT", self.PriorityFrame, "TOPRIGHT" ,(12), -Watcher.db.char.priority.IconSize -(Watcher.db.char.priority.fWidth * self.db.char.priority.maxtime / 1.5))
		end
		self.PriorityFrame.axisbase.text:SetText(self.db.char.priority.maxtime)
	end	


function Watcher:Axis()
	self.PriorityFrame.axisbase:ClearAllPoints()
	if not self.PriorityFrame.axis then
		self.PriorityFrame.axis = self.PriorityFrame.axisbase:CreateTexture(nil, "OVERLAY")
	end
	self.PriorityFrame.axisbase:ClearAllPoints()
	self.PriorityFrame.axis:ClearAllPoints()
	if self.db.char.growdir == "right" then
	self.PriorityFrame.axis:SetWidth(Watcher.db.char.priority.fWidth * (self.db.char.priority.maxtime) / 1.5)
	self.PriorityFrame.axis:SetHeight(self.db.char.priority.fHeight / 10)
	self.PriorityFrame.axis:SetPoint("TOPLEFT", self.PriorityFrame, "BOTTOMLEFT", Watcher.db.char.priority.IconSize, 0)
	elseif self.db.char.growdir == "left" then
	self.PriorityFrame.axis:SetWidth(Watcher.db.char.priority.fWidth * self.db.char.priority.maxtime / 1.5)
	self.PriorityFrame.axis:SetHeight(self.db.char.priority.fHeight / 10)
	self.PriorityFrame.axis:SetPoint("TOPRIGHT", self.PriorityFrame, "BOTTOMRIGHT", -Watcher.db.char.priority.IconSize, 0)
	elseif self.db.char.growdir == "down" then
	self.PriorityFrame.axis:SetHeight(Watcher.db.char.priority.fWidth * self.db.char.priority.maxtime / 1.5)
	self.PriorityFrame.axis:SetWidth(self.db.char.priority.fHeight / 10)
	self.PriorityFrame.axis:SetPoint("TOPLEFT", self.PriorityFrame, "TOPRIGHT", 0, -Watcher.db.char.priority.IconSize)
	elseif self.db.char.growdir == "up" then
	self.PriorityFrame.axis:SetHeight(Watcher.db.char.priority.fWidth * self.db.char.priority.maxtime / 1.5)
	self.PriorityFrame.axis:SetWidth(self.db.char.priority.fHeight / 10)
	self.PriorityFrame.axis:SetPoint("TOPLEFT", self.PriorityFrame, "TOPRIGHT", 0,0)
	end
	self.PriorityFrame.axis:SetTexture(1, 1, 1, 1)
	self.PriorityFrame.axis:Show()
	
	if not self.PriorityFrame.axisgcd then -- "Finish Line"
		self.PriorityFrame.axisgcd = self.PriorityFrame.axisbase:CreateTexture(nil, "OVERLAY")
	end
	--self.PriorityFrame.axisgcd:SetFrameLevel(10)
	self.PriorityFrame.axisgcd:ClearAllPoints()
	if self.db.char.growdir == "right" then
	self.PriorityFrame.axisgcd:SetHeight(Watcher.db.char.priority.IconSize)
	self.PriorityFrame.axisgcd:SetWidth(self.db.char.priority.fHeight / 10)
	self.PriorityFrame.axisgcd:SetPoint("BOTTOMLEFT", self.PriorityFrame, "BOTTOMLEFT",Watcher.db.char.priority.IconSize, 0)
	end
	if self.db.char.growdir == "left" then
	self.PriorityFrame.axisgcd:SetHeight(Watcher.db.char.priority.IconSize)
	self.PriorityFrame.axisgcd:SetWidth(self.db.char.priority.fHeight / 10)
	self.PriorityFrame.axisgcd:SetPoint("BOTTOMRIGHT", self.PriorityFrame, "BOTTOMRIGHT",-Watcher.db.char.priority.IconSize, 0)
	end
	if self.db.char.growdir == "down" then
	self.PriorityFrame.axisgcd:SetWidth(Watcher.db.char.priority.IconSize)
	self.PriorityFrame.axisgcd:SetHeight(self.db.char.priority.fHeight / 10)
	self.PriorityFrame.axisgcd:SetPoint("TOPRIGHT", self.PriorityFrame, "TOPRIGHT",0, -Watcher.db.char.priority.IconSize)
	end
	if self.db.char.growdir == "up" then
	self.PriorityFrame.axisgcd:SetWidth(Watcher.db.char.priority.IconSize)
	self.PriorityFrame.axisgcd:SetHeight(self.db.char.priority.fHeight / 10)
	self.PriorityFrame.axisgcd:SetPoint("BOTTOMLEFT", self.PriorityFrame, "BOTTOMLEFT",0, Watcher.db.char.priority.IconSize)
	end
	self.PriorityFrame.axisgcd:SetTexture(0, 0, 0, 1)
	self.PriorityFrame.axisgcd:Show()
	self:AxisText()
	if (self.db.char.showaxis) then
		self.PriorityFrame.axisbase:SetAlpha(1)
	else
		self.PriorityFrame.axisbase:SetAlpha(0)
	end
end

function Watcher:SetPriorityFrame(FrameName, optionnum)
	FrameName:ClearAllPoints()
	FrameName:SetFrameStrata("BACKGROUND")
	FrameName:SetFrameLevel(9 - optionnum)
	FrameName:SetWidth(Watcher.db.char.priority.IconSize)
	FrameName:SetHeight(self.db.char.priority.IconSize)
	if optionnum == 1 then
	FrameName:SetBackdrop({ bgFile = Watcher.priorityTable.icon[self.db.char.priority.option[optionnum]],
		edgeFile = "none",
		tile = false, tileSize = 0, edgeSize = 0,
		insets = { left = 0, right = 0, top = 0, bottom = 0 }})
		FrameName:SetBackdropColor(0, 0, 0, 1);
	if self.db.char.growdir == "right" or "left" then
		FrameName:SetHeight(self.db.char.priority.fHeight / 3)
	end
	else
	FrameName:SetBackdrop({ bgFile = Watcher.priorityTable.icon[self.db.char.priority.option[optionnum]],
		edgeFile = "none",
		tile = false, tileSize = 0, edgeSize = 0,
		insets = { left = 0, right = 0, top = 0, bottom = 0 }})
		FrameName:SetBackdropColor(1, 1, 1, 1);
		FrameName:SetAlpha(1)
	end
	if not FrameName.Text then
		FrameName.Text = FrameName:CreateFontString(nil, "OVERLAY")
	end
	FrameName.Text:SetTextColor(1,1,1,1)
	FrameName.Text:SetFont(media:Fetch("font", self.db.char.iconfont), self.db.char.iconfontsize, self.db.char.iconfonteffect)
	if self.db.char.textpoint == "top" then
	FrameName.Text:SetPoint("TOP", FrameName, "TOP", 0, self.db.char.iconfontsize + 2)
	elseif self.db.char.textpoint == "bottom" then
	FrameName.Text:SetPoint("BOTTOM", FrameName, "BOTTOM", 0, -self.db.char.iconfontsize + 2)
	elseif self.db.char.textpoint == "center" then
	FrameName.Text:SetPoint("CENTER", FrameName, "CENTER", 0, 0)
	end
	FrameName:SetScript("OnUpdate", 
		function()
				if combat == true or self.db.char.showcombat == false then
					Watcher.priorityTable.check[self.db.char.priority.option[optionnum]](FrameName, optionnum)
				end
		end	);	
	if self.db.char.showcombat == true then
		if combat == true then
			FrameName:Show()
		else
			FrameName:Hide()
		end
	else
		FrameName:Show()
	end
	if self.db.char.priority.iconcd then
		FrameName.Text:Show()
	else
		FrameName.Text:Hide()
	end
end


function Watcher:ResetPriority()
	self.PriorityFrame:ClearAllPoints()
	self.db.char.priority.point = self.defaults.char.priority.point
	self.db.char.priority.relativeTo = self.defaults.char.priority.relativeTo 
	self.db.char.priority.relativePoint = self.defaults.char.priority.relativePoint
	self.db.char.priority.xOffset = self.defaults.char.priority.xOffset
	self.db.char.priority.yOffset = self.defaults.char.priority.yOffset
	Watcher.db.char.priority.fWidth = self.defaults.char.priority.fWidth
	self.db.char.priority.fHeight = self.defaults.char.priority.fHeight
	self.db.char.scale = self.defaults.char.priority.scale
	self.db.char.priority.option = self.defaults.char.priority.option
	self.PriorityFrame:SetPoint(self.db.char.priority.point, self.db.char.priority.relativeTo, self.db.char.priority.relativePoint, self.db.char.priority.xOffset, self.db.char.priority.yOffset)
	self:CreatePriorityFrame()
	self:Print(L["priority_reset"])
end

function Watcher:expires(expiresin, dotthreshold, typedot, typeShortDot, buffproc)
	if buffproc then
		return false
	elseif typeShortDot and expiresin > dotthreshold then
		return true
	elseif typedot and expiresin > dotthreshold then
		return true
	end
		return false
end

function Watcher:countcheck(count, countreq, timeleft)
	if countreq == 0 then
		return true
	elseif count == countreq then
		return true
	elseif count ~= countreq and timeleft > 0 then
		return true
	end
	return false
end

function Watcher:UpdateSpell(FrameName, optionnum, typedot, dotfunction, typeShortDot, shortDotTime, usehealthpc, SpellName, powerthreshold, countreq, dotthreshold, combocost) 
		FrameName:SetAlpha(1)
		local usable,_ = IsUsableSpell(SpellName)
		local creatureType = UnitCreatureType("target")
		if typereq == nil or typereq == 0 then typereq = creatureType end
		local expiresin, count
		local power = UnitPower("player")
		local combo = GetComboPoints("player", "target")
		if combocost == nil then combocost = 0 end
		local buffproc = false
		if typedot and not typeShortDot then
			expiresin, count = dotfunction
		elseif typeShortDot and not typedot then
			expiresin = shortDotTime - GetTime()
			count = 0
		elseif typedot and typeShortDot then -- Quick work around to detect proc buffs for certain abilities - ie Slam! for warriors
			expiresin, count = dotfunction
			buffproc = true
		else
			expiresin = 0
			count = 0
		end
		local start, duration = GetSpellCooldown(SpellName) -- must be same as earlier
		if start == nil then
			start = 0
			duration = 0
		end
		local timeleft = start + duration - GetTime()
		if Watcher:bossmob(optionnum) then
					if buffproc == false or expiresin > 0 then
					if usable == 1 then
					if combo >= combocost then
					if Watcher:countcheck(count, countreq, timeleft) then
						if Watcher:expires(expiresin, dotthreshold, typedot, typeShortDot, buffproc) or timeleft > 0 then
							if timeleft < expiresin and not buffproc then
								timeleft = expiresin
							end
							Watcher.timeLeft[optionnum] = timeleft
							Watcher:MoveIcon(FrameName, timeleft - dotthreshold, optionnum)
							if Watcher.db.char.priority.textshow then
								FrameName.Text:SetText(Watcher:DurationString(timeleft))
								FrameName.Text:Show()
							else
								FrameName.Text:Hide()
							end
							ready[optionnum] = false		
							if timeleft > Watcher.db.char.priority.maxtime then
								FrameName:SetAlpha(0)
							else
								FrameName:SetAlpha(1)
							end
							return
							end
						end
					FrameName.Text:Hide()
					ready[optionnum] = true
					Watcher.timeLeft[optionnum] = 0
					Watcher:GetReady(optionnum)
					Watcher:SetReadyPoint(FrameName, Watcher.offset)
					return
				end -- combo
				end -- usable
				end -- buffproc
		end -- boss
		ready[optionnum] = false
		FrameName:SetAlpha(0)
		Watcher.timeLeft[optionnum] = 0
		end
		
		
		
	