if not Watcher then return end

if select(2, UnitClass('player')) ~= "PALADIN" then return end

local LBF = LibStub("LibButtonFacade", true)
local L = LibStub("AceLocale-3.0"):GetLocale("Watcher")
local media = LibStub:GetLibrary("LibSharedMedia-3.0");
local C = Watcher.constants
	
C["Crusader Strike"], _, C["Crusader Strike Icon"] = GetSpellInfo(35395)
C["Blessing of Might"], _, C["Blessing of Might Icon"] = GetSpellInfo(48932)
C["Hammer of Wrath"], _, C["Hammer of Wrath Icon"] = GetSpellInfo(48806)
C["Divine Storm"], _, C["Divine Storm Icon"] = GetSpellInfo(53385)
C["Judgement of Wisdom"], _, C["Judgement of Wisdom Icon"] = GetSpellInfo(53408)
C["Judgement of Light"], _, C["Judgement of Light Icon"] = GetSpellInfo(20271)
C["Holy Wrath"], _, C["Holy Wrath Icon"] = GetSpellInfo(2812)
C["Avenging Wrath"], _, C["Avenging Wrath Icon"] = GetSpellInfo(31884)
C["Exorcism"], _, C["Exorcism Icon"] = GetSpellInfo(48801)
C["Consecration"], _, C["Consecration Icon"] = GetSpellInfo(48819)

function Watcher:UNIT_SPELLCAST_SUCCEEDED()
end

Watcher.priorityTable.name["CS"] = C["Crusader Strike"]
Watcher.priorityTable.icon["CS"] = C["Crusader Strike Icon"]
Watcher.priorityTable.check["CS"] =  
	function (FrameName, optionnum) 	
		Watcher:UpdateSpell(FrameName, optionnum, false, 0, false, 0, 1, C["Crusader Strike"], 0, 0, 0)
	end
	
Watcher.priorityTable.name["cons"] = C["Consecration"]
Watcher.priorityTable.icon["cons"] = C["Consecration Icon"]
Watcher.priorityTable.check["cons"] =  
	function (FrameName, optionnum) 	
		Watcher:UpdateSpell(FrameName, optionnum, false, 0, false, 0, 1, C["Consecration"], 0, 0, 0)
	end
	
Watcher.priorityTable.name["AW"] = C["Avenging Wrath"]
Watcher.priorityTable.icon["AW"] = C["Avenging Wrath Icon"]
Watcher.priorityTable.check["AW"] =  
	function (FrameName, optionnum) 	
		Watcher:UpdateSpell(FrameName, optionnum, false, 0, false, 0, 1, C["Avenging Wrath"], 0, 0, 0)	
	end
	
Watcher.priorityTable.name["HOW"] = C["Hammer of Wrath"]
Watcher.priorityTable.icon["HOW"] = C["Hammer of Wrath Icon"]
Watcher.priorityTable.check["HOW"] =  
	function (FrameName, optionnum) 	
		Watcher:UpdateSpell(FrameName, optionnum, false, 0, false, 0, 0.2, C["Hammer of Wrath"], 0, 0, 0) 
	end
	
Watcher.priorityTable.name["JOL"] = C["Judgement of Light"]
Watcher.priorityTable.icon["JOL"] = C["Judgement of Light Icon"]
Watcher.priorityTable.check["JOL"] =  
	function (FrameName, optionnum) 	
Watcher:UpdateSpell(FrameName, optionnum, false, 0, false, 0, 1, C["Judgement of Light"], 0, 0, 0)
	end
	
Watcher.priorityTable.name["JOW"] = C["Judgement of Wisdom"]
Watcher.priorityTable.icon["JOW"] = C["Judgement of Wisdom Icon"]
Watcher.priorityTable.check["JOW"] =  
	function (FrameName, optionnum) 	
	Watcher:UpdateSpell(FrameName, optionnum, false, 0, false, 0, 1, C["Judgement of Light"], 0, 0, 0)
	end
	
Watcher.priorityTable.name["HW"] = C["Holy Wrath"]
Watcher.priorityTable.icon["HW"] = C["Holy Wrath Icon"]
Watcher.priorityTable.check["HW"] =  
	function (FrameName, optionnum) 	
	Watcher:UpdateSpell(FrameName, optionnum, false, 0, false, 0, 1, C["Holy Wrath"], 0, 0, 0, 0)
	end
	
Watcher.priorityTable.name["DS"] = C["Divine Storm"]
Watcher.priorityTable.icon["DS"] = C["Divine Storm Icon"]
Watcher.priorityTable.check["DS"] =  
	function (FrameName, optionnum) 	
	Watcher:UpdateSpell(FrameName, optionnum, false, 0, false, 0, 1, C["Divine Storm"], 0, 0, 0)
	end
	
Watcher.priorityTable.name["Ex"] = C["Exorcism"]
Watcher.priorityTable.icon["Ex"] = C["Exorcism Icon"]
Watcher.priorityTable.check["Ex"] =  
	function (FrameName, optionnum) 	
	Watcher:UpdateSpell(FrameName, optionnum, false, 0, false, 0, 1, C["Exorcism"], 0, 0, 0, 0)
	end
		
Watcher.priorityTable.name["gcd"] = C["Blessing of Might"]
Watcher.priorityTable.icon["gcd"] = C["Blessing of Might"]
Watcher.priorityTable.check["gcd"] =  
	function (FrameName, optionnum) 	
		local start, duration = GetSpellCooldown(C["Blessing of Might"])
		if duration > 0 then
			FrameName:SetAlpha(1)
			local timeleft = start + duration - GetTime()
			Watcher:MoveIcon(FrameName, timeleft)
			FrameName.Text:SetText(Watcher:DurationString(timeleft))
			return
		end
		if start == 0 then
			FrameName.Text:Hide()
			FrameName:SetAlpha(0)
		else
			FrameName.Text:Show()
		end
	end 
